.686
.model flat, stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\masm32.inc
include \masm32\include\user32.inc
include \masm32\macros\macros.asm

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\user32.lib
include TIMERS.ASM

  zero_it 		proto 	:DWORD,:DWORD
  xzero_it 		proto 	:DWORD,:DWORD
  ZeroMemD 		proto 	:DWORD,:DWORD
  fZeroMemory 	proto   :DWORD,:DWORD
  xzero_it2 	proto   :DWORD,:DWORD

       
.data?
szBuff db 1024 dup(?)       

.data
iString db "Do you like beer? I like beer, so much infact I may start a save beer foundation.",0

.code
start:
invoke lstrcpy,addr szBuff,addr iString
LOOP_COUNT EQU 1000000
counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
invoke  zero_it,addr szBuff,1024
counter_end
push eax
print chr$("zero_it - hutch: ")
pop eax
print str$(eax)
print chr$(13,10)

invoke lstrcpy,addr szBuff,addr iString
LOOP_COUNT EQU 1000000
counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
invoke  xzero_it,addr szBuff,1024
counter_end
push eax
print chr$("xzero_it - The Dude of Dudes: ")
pop eax
print str$(eax)
print chr$(13,10)

invoke lstrcpy,addr szBuff,addr iString
LOOP_COUNT EQU 1000000
counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
invoke  xzero_it2,addr szBuff,1024
counter_end
push eax
print chr$("xzero_it2 - pro3carp3: ")
pop eax
print str$(eax)  
print chr$(13,10)

invoke lstrcpy,addr szBuff,addr iString
LOOP_COUNT EQU 1000000
counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
invoke RtlZeroMemory,addr szBuff,1024
counter_end
push eax
print chr$("RtlZeroMemory - Microsoft: ")
pop eax
print str$(eax) 
print chr$(13,10)

invoke lstrcpy,addr szBuff,addr iString
LOOP_COUNT EQU 1000000
counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
invoke ZeroMemD,addr szBuff,1024
counter_end
push eax
print chr$("ZeroMemD - unknown: ")
pop eax
print str$(eax)
print chr$(13,10)

invoke lstrcpy,addr szBuff,addr iString
LOOP_COUNT EQU 1000000
counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
invoke fZeroMemory,addr szBuff,1024
counter_end
push eax
print chr$("fZeroMemory- Four-F: ")
pop eax
print str$(eax)
print chr$(13,10)

invoke ExitProcess,0

align 4
;by hutch
zero_it proc lpmem:DWORD,cnt:DWORD

    mov ecx, lpmem          ; address in ECX
    mov edx, cnt            ; Count in EDX
    xor eax, eax            ; set EAX to zero to zero AL

  @@:
    mov [ecx+edx], al       ; zero byte at address in ECX
    sub edx, 1              ; decrement EDX
    jns @B                  ; loop back if > -1

    ret

zero_it endp
      
;by The Dude of Dudes                  
xzero_it proc lpmem:DWORD,cnt:DWORD

mov edi, lpmem
mov ecx, cnt     
shr ecx, 2       ;<----- div by 4 (sizeof dword)
;inc ecx           <------ not necessary
cld
xor eax, eax   ; set EAX to zero
rep stosd       ;<------- instead of stosb, stores a dword every iteration and adds 4 to edi
ret

xzero_it endp

;pro3carp3
xzero_it2 proc lpmem:DWORD, cnt:DWORD

cld
xor eax, eax
mov edi, lpmem
mov ecx, cnt
mov edx, ecx   
shr ecx, 2d
rep stosd
mov ecx, edx
and ecx, 3d    ; <-- correction
rep stosb

ret

xzero_it2 endp

;by ?
ZeroMemD proc dest:DWORD,lenx:DWORD

; taking into account xor eax, eax
; ProcSize = 48 bytes

push edi
        mov  edi, dest								; <---- !!! moved by me (Four-F) otherwise crash if len<4
        cld											; <---- added by me (Four-F)
        cmp  lenx, 4        ; if < DWORD size
        jl  @@@1           ; copy as BYTE
        

        mov  ecx, lenx

        push ecx           ; copy ecx
        shr  ecx, 2        ; integer divide by 4
        shl  ecx, 2        ; multiply by 4 for dividend
        pop  edx
        sub  edx, ecx      ; remainder in edx
        shr  ecx, 2           ; div by 4 for DWORD

        rep  stosd         ; copy as DWORD
        mov  ecx, edx      ; put remainder in counter
        jmp  @@@2

      @@@1:
        mov  ecx, lenx
      @@@2:
        rep  stosb         ; copy as BYTE
pop edi
        ret

ZeroMemD endp

;by Four-F
fZeroMemory proc pDest:LPVOID, cbLen:UINT

; (c) Four-F, 2002
; four-f@mail.ru

; Assume pDest is valid

; ProcSize = 32 bytes

option PROLOGUE:NONE
option EPILOGUE:NONE

	xor eax, eax
	push edi
	mov ecx, [esp + sizeof DWORD * 3]
	mov edx, ecx
	cld
	mov edi, [esp + sizeof DWORD * 2]
	shr ecx, 2
	jz @F
	rep stosd
@@:
	and edx, 011y
	mov ecx, edx
	rep stosb
	pop edi

	ret (sizeof DWORD)*2

option PROLOGUE:PROLOGUEDEF
option EPILOGUE:EPILOGUEDEF

fZeroMemory endp

end start